/* GStreamer
 * Copyright (C) 2013 Hansen
 * gstmultifilesink.c:
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif



#include <gst/gst.h>

#include <ros/ros.h>
#include <sensor_msgs/Image.h>
//#include <cv_bridge/CvBridge.h>
#include <image_transport/image_transport.h>

#include "roscommon.h"
#include "gstrossrc.h"
#include "gstrossink.h"
#include "gstrosparam.h"
#include "gstrossiftfolder.h"
#include "gstrosundistort.h"
#include "gstrostfpub.h"
#include "gstrossift3d.h"

static gboolean
plugin_init (GstPlugin * plugin)
{
  //gst_element_register (plugin, "multifilesrc", GST_RANK_NONE,
  //    gst_multi_file_src_get_type ());
  gst_element_register (plugin, "rossrc", GST_RANK_NONE, GST_TYPE_ROSSRC);
  gst_element_register (plugin, "rossink", GST_RANK_NONE,
      GST_TYPE_ROSSINK);
  gst_element_register (plugin, "rosparam", GST_RANK_NONE,
      GST_TYPE_ROSPARAM);
  gst_element_register (plugin, "rossiftfolder", GST_RANK_NONE,
      GST_TYPE_ROSSIFTFOLDER);  
  gst_element_register (plugin, "rosundistort", GST_RANK_NONE,
      GST_TYPE_ROSUNDISTORT);
  gst_element_register (plugin, "rostfpub", GST_RANK_NONE,
      GST_TYPE_ROSTFPUB);
  gst_element_register (plugin, "rossift3d", GST_RANK_NONE,
      GST_TYPE_ROSSIFT3D);
  int x=1;
  little_endian=(gboolean) (*(char*)&x); 
  return TRUE;
}

GST_PLUGIN_DEFINE (GST_VERSION_MAJOR,
    GST_VERSION_MINOR,
    "ros",
    "Exchanges Data with ROS (Robot Operating System)",
    plugin_init, VERSION, "LGPL", "gst-plugins-robotix", "Mostly from Hannes Bistry");
